<id>
din1031:MemberColorLink
</id>

<version>
2.1.5
</version>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			'layout' => array(
				'title' => $txt['mods_cat_layout'],
				'href' => $scripturl . '?action=featuresettings;sa=layout;sesc=' . $context['session_id'],
			),
</search for>

<replace>
			'layout' => array(
				'title' => $txt['mods_cat_layout'],
				'href' => $scripturl . '?action=featuresettings;sa=layout;sesc=' . $context['session_id'],
			),
			'MemberColorLinks' => array(
				'title' => $txt['MemberColorLinkHeadline'],
				'href' => $scripturl . '?action=featuresettings;sa=MemberColorLinks;sesc=' . $context['session_id'],
			),
</replace>

<search for>
		'layout' => 'ModifyLayoutSettings',
</search for>

<replace>
		'layout' => 'ModifyLayoutSettings',
		'MemberColorLinks' => 'ModifyMemberColorLinksSettings',
</replace>

<search for>
	$context['post_url'] = $scripturl . '?action=featuresettings2;save;sa=karma';
	$context['settings_title'] = $txt['smf293'];

	prepareDBSettingContext($config_vars);
}
</search for>

<add after>
function ModifyMemberColorLinksSettings()
{
	global $txt, $scripturl, $context, $settings, $sc;

	$config_vars = array(
			// Standard Membercolor?
			array('check', 'MemberColorLink'),
		'',
			//Some Stat Settings
			array('check', 'MemberColorLatestMember'),
			array('check', 'MemberColorStats'),
			array('check', 'MemberColorWhoIsOnline'),
		'',
			//Thread and Boardsettings
			array('check', 'MemberColorThreadOwner'),
			array('check', 'MemberColorThreadLastPost'),
			array('check', 'MemberColorThreadChild'),
		'',
			//Birthday and Calendar 
			array('check', 'MemberColorModeratorLinks'),
			array('check', 'MemberColorBoardindex'),
			array('check', 'MemberColorBirthday'),
		'',
			//Some Recent Things
			array('check', 'MemberColorRecentOwner'),
			array('check', 'MemberColorRecentLastPost'),
		'',
			// PM Colors
			array('check', 'MemberColorInbox'),
			array('check', 'MemberColorOutbox'),
		'',
			//Guest Color
			array('text', 'MemberColorGuests'),
			//Banned User Color
			array('text', 'MemberColorBanned'),
	);

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=featuresettings;sa=MemberColorLinks');
	}

	$context['post_url'] = $scripturl . '?action=featuresettings2;save;sa=MemberColorLinks';
	$context['settings_title'] = $txt['MemberColorLinkHeadline'];

	prepareDBSettingContext($config_vars);
}
</add after>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</search for>

<replace>
	array loadOnlineColors(array members, bool returnarray = true)
		- This function is for Modcreators who like to color the nicks if the MemberColorLink is installed
		  with this function the user can check if the function exists and load the colors if needed.
		  But please load so many ids as possible at one time, to reduce the database querys.
		  To Check if the function exist use if(function_exists('loadOnlineColors')) {}
		- return a array with follow informations
			array(id_member => array(online_color => '', colored_name => '', colored_link => '');
		- chache datas the global $color_profile (only the db data, not the array data above)
		- return "false" on nothing loaded!

	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</replace>

<search for>
			$user_profile[$row['ID_MEMBER']] = $row;
</search for>

<replace>
			$user_profile[$row['ID_MEMBER']] = $row;
			//Color Banned user, replace there color... hope they are not moderators ;P?
			if(!empty($modSettings['MemberColorBanned']) && isset($row['is_activated']) && $row['is_activated'] >= 10) {
				$user_profile[$row['ID_MEMBER']]['post_group_color'] = $modSettings['MemberColorBanned'];
				$user_profile[$row['ID_MEMBER']]['member_group_color'] = $modSettings['MemberColorBanned'];
			}
</replace>

<search for>
		'username' => &$profile['memberName'],
		'name' => &$profile['realName'],
</search for>

<replace>
		'username' => &$profile['memberName'],
		'name' => &$profile['realName'],
		'colored_name' => (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) . $profile['realName'] . (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '</span>' : ''),
		'online_color' => (!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']),
</replace>

<search for>
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . $profile['realName'] . '</a>',
</search for>

<replace>
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . (!empty($modSettings['MemberColorLink']) ? ( !empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) : '' ) . $profile['realName'] . (!empty($modSettings['MemberColorLink']) && (!empty($profile['member_group_color']) || !empty($profile['post_group_color'])) ? '</span>' : '' ).'</a>',
		'colorless_link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . $profile['realName'] . '</a>',
</replace>

<search for>
// Load a theme, by ID.
</search for>

<replace>
//This is the universion load colors function, can be used by each person who need it :)
//I think it's intressting for mod Creators =D
//SMF 1.1.x Version

function load_onlineColors($users, $returnarray = true) {
	global $color_profile, $db_prefix, $modSettings;

	//Make something for sure :)
	if(!isset($color_profile))
		$color_profile = array();
	//Set a standard empty array for guest errors ;) (Deleted users, which are not resetet)
	if(!isset($color_profile[0]))
		$color_profile[0] = array('member_group_color' => '', 'post_group_color' => '');
	
	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);

	//Now i will use this as a chache, too
	$loaded_ids = array();
	$all_loaded_ids = array_keys($color_profile);
	//All the users that allready loaded
	$loaded_ids = array_intersect($all_loaded_ids, $users);
	//Now i need only the new users to load
	$users = array_diff($users, $all_loaded_ids);

	if(!empty($users)) {
		// Load the data.
		$request = db_query("
			SELECT
			mem.ID_MEMBER AS ID_MEMBER, mem.realName AS realName,
			mg.onlineColor AS member_group_color, IFNULL(mg.groupName, '') AS member_group,
			pg.onlineColor AS post_group_color, IFNULL(pg.groupName, '') AS post_group
			FROM {$db_prefix}members AS mem
			LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
			WHERE mem.ID_MEMBER ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"), __FILE__, __LINE__);

		while ($row = mysql_fetch_assoc($request))
		{
			$loaded_ids[] = $row['ID_MEMBER'];
			$color_profile[$row['ID_MEMBER']] = $row;
		}
		mysql_free_result($request);
	}
	
	//Build the Array ;D
	$array = array();
	if(!empty($loaded_ids) && $returnarray == true) {
		global $txt, $scripturl;
		foreach($loaded_ids as $id) {
			$profile = $color_profile[$id];
			$onlineColor = !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'];
			$array[$id] = array(
				'id' => $id,
				'online_color' => $onlineColor,
				'colored_name' => (!empty($onlineColor) ? '<span style="color:'.$onlineColor.';">' : '' ) . $profile['realName'] . (!empty($onlineColor) ? '</span>' : ''),
				'colored_link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"'.(!empty($onlineColor) ? ' style="color:'.$onlineColor.';"' : '').'>' . $profile['realName'] .'</a>',
			);
		}	
	}
	//Return that what should returned XD
	return (empty($loaded_ids) ? false : ($returnarray == true ? $array : $loaded_ids));
}

// Load a theme, by ID.
</replace>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
	// Aren't children wonderful things?
	$result = db_query("
</search for>

<add before>
	//Set some standard Variables for the MemberColorLink
	$MemberSetColor = FALSE;
	if (!empty($modSettings['MemberColorThreadOwner']) || !empty($modSettings['MemberColorThreadLastPost']) || !empty($modSettings['MemberColorChild']) || (!empty($modSettings['MemberColorWhoIsOnline']) && !empty($settings['display_who_viewing'])))
		$MemberColor_ID_MEMBER = array();

</add before>

<search for>
				$theboards[] = $row_board['ID_BOARD'];
</search for>

<add after>

				//The Last Posts of the Children MemberColor.
				if (!empty($modSettings['MemberColorThreadChild']) && !empty($row_board['ID_MEMBER'])) {
						$MemberColor_ID_MEMBER[$row_board['ID_MEMBER']] = $row_board['ID_MEMBER'];
						$MemberSetColor = TRUE;
				}
</add after>

<search for>
			if (empty($row['showOnline']))
				$context['view_num_hidden']++;
		}
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);
</search for>

<replace>
				if (!empty($modSettings['MemberColorWhoIsOnline'])) {
					$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
					$MemberSetColor = TRUE;
				}

			if (empty($row['showOnline']))
				$context['view_num_hidden']++;
		}
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);
</replace>

<search for>
			if (!$pre_query)
				$topic_ids[] = $row['ID_TOPIC'];
</search for>

<add after>

		//I need to collect some IDs for the MemberColor :).
		if (!empty($modSettings['MemberColorThreadOwner']) && !empty($row['firstID_MEMBER'])) {
				$MemberColor_ID_MEMBER[$row['firstID_MEMBER']] = $row['firstID_MEMBER'];
				$MemberSetColor = TRUE;
		}
		//Oh i need the Last Post ID, too ;)
		if (!empty($modSettings['MemberColorThreadLastPost']) && !empty($row['lastID_MEMBER'])) {
				$MemberColor_ID_MEMBER[$row['lastID_MEMBER']] = $row['lastID_MEMBER'];
				$MemberSetColor = TRUE;
		}
</add after>

<search for>
			determineTopicClass($context['topics'][$row['ID_TOPIC']]);
		}
		mysql_free_result($result);
</search for>

<add after>

		//Now let's replace the orginal link to the Color Link ;)
		if ($MemberSetColor && !empty($MemberColor_ID_MEMBER)) {
			//Now Load the Missing global :)
			global $user_profile;

			loadMemberData($MemberColor_ID_MEMBER);
			$cmemcolid = NULL;

			//You are not know what you do ;P Colors allready loaded :D
			if(!empty($modSettings['MemberColorModeratorLinks']) && !empty($theboards)) {
				//Okay now... do a heavy serach for moderators... only jokeing... but you know... it look so ugly ;)
				foreach($theboards as $boardid_memcolor) {
					//Reset it :D
					$context['boards'][$boardid_memcolor]['link_moderators'] = array();
					foreach($context['boards'][$boardid_memcolor]['moderators'] as $moderators) {
						$cmemcolid = $moderators['id'];
						$profile = &$user_profile[$cmemcolid];
						//Standard Color ;)
						if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
							$context['boards'][$boardid_memcolor]['moderators'][$cmemcolid]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';

						//Creat the new list...
						$context['boards'][$boardid_memcolor]['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[62] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
					}
				}
			}

			//Need the Childs some Colors XD
			if (!empty($modSettings['MemberColorThreadChild']))
				if(!empty($theboards))
				foreach($theboards as $boardid_memcolor) {
					//My Childs need a Member Color ;)
					$cmemcolid = $context['boards'][$boardid_memcolor]['last_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['boards'][$boardid_memcolor]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				}
			//The Owner or the Last Post of the thread
			if (!empty($modSettings['MemberColorThreadOwner']) || !empty($modSettings['MemberColorThreadLastPost']))
				foreach($topic_ids as $topicid_memcolor) {
					//First the Thread Owner Link
					if (!empty($modSettings['MemberColorThreadOwner'])) {
						$cmemcolid = $context['topics'][$topicid_memcolor]['first_post']['member']['id'];
						$profile = &$user_profile[$cmemcolid];
						if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
							$context['topics'][$topicid_memcolor]['first_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
					}
					//Or the Last Post Link ;)
					if (!empty($modSettings['MemberColorThreadLastPost'])) {
						$cmemcolid = $context['topics'][$topicid_memcolor]['last_post']['member']['id'];
						$profile = &$user_profile[$cmemcolid];
						if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
							$context['topics'][$topicid_memcolor]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
					}
				}
			if (!empty($settings['display_who_viewing']) && !empty($modSettings['MemberColorWhoIsOnline']) && !empty($context['view_members'])) {
				//I need the new not numeric keys :)
				$klist = array_keys($context['view_members']);
				foreach($klist as $value) {
					$id = $context['view_members'][$value]['id'];
					$profile = &$user_profile[$id];
					//Let's replace Who is online colors...
					$hidden_user = $context['view_members'][$value]['hidden'];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color'])) {
						$context['view_members'][$value]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
						//Somehow the 'view_members_list' must be the same as before *g*, i don't like the hidden users...
						if (!$hidden_user || allowedTo('moderate_forum'))
							$context['view_members_list'][$value] = ($hidden_user ? '<i>' : '').'<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>'.($hidden_user ? '</i>' : '');
					}
				}
			}
		}
</add after>

<edit file>
$sourcedir/BoardIndex.php
</edit file>

<search for>
			if (!empty($row_board['ID_MODERATOR']))
			{
</search for>

<replace>
			if (!empty($row_board['ID_MODERATOR']))
			{
				//Color the Mods, too...
				if(!empty($modSettings['MemberColorModeratorLinks'])) {
					$MemberColor_ID_MEMBER[$row_board['ID_MODERATOR']] = $row_board['ID_MODERATOR'];
					$MemberColor_ModBoard[$isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']] = array(
						'bid' => ($isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']),
						'cat' => $row_board['ID_CAT']
					);
				}
</replace>

<search for>
				'link' => $row_board['posterName'] != '' ? (!empty($row_board['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['ID_MEMBER'] . '">' . $row_board['realName'] . '</a>' : $row_board['realName']) : $txt[470],
</search for>

<replace>
				'link' => $row_board['posterName'] != '' ? (!empty($row_board['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['ID_MEMBER'] . '">' . $row_board['realName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row_board['realName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')) : $txt[470],
</replace>

<search for>
			'start' => 'msg' . $row_board['new_from'],
			'topic' => $row_board['ID_TOPIC']
		);
</search for>

<add after>
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($row_board['ID_MEMBER'])) {
			$MemberColor_ID_MEMBER[$row_board['ID_MEMBER']] = $row_board['ID_MEMBER'];
			$MemberColor_board[$isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']] = array(
			'bid' => ($isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']),
			'cat' => $row_board['ID_CAT']);
		}
</add after>

<search for>
		// Determine a global most recent topic.
		if (!empty($row_board['posterTime']) && forum_time(true, $row_board['posterTime']) > $most_recent_topic['timestamp'])
			$most_recent_topic = array(
				'timestamp' => forum_time(true, $row_board['posterTime']),
				'ref' => &$this_category[$isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']]['last_post'],
			);
	}
	mysql_free_result($result_boards);
</search for>

<add after>
	//The latest member?
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$MemberColor_ID_MEMBER[$modSettings['latestMember']] = $modSettings['latestMember'];

	// Know set the colors for the last post...
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So the BoardIndex need colored links
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($MemberColor_board))
			foreach($MemberColor_board as $boardid_memcolor) {
				$cmemcolid = $context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
			}

		//You are not know what you do ;P Colors allready loaded :D
		if(!empty($modSettings['MemberColorModeratorLinks']) && !empty($MemberColor_ModBoard)) {
			//Okay now... do a heavy serach for moderators... only jokeing... but you know... it look so ugly ;)
			//I need to load here the color, and only here ;)
			$onlineColor = '';
			$modColor = db_query("
			SELECT onlineColor FROM {$db_prefix}membergroups
			WHERE ID_GROUP = 3
			LIMIT 1", __FILE__, __LINE__);
			
			list($onlineColor) = mysql_fetch_row($modColor);
			mysql_free_result($modColor);
						
			foreach($MemberColor_ModBoard as $boardid_memcolor) {
				//Reset it :D
				$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['link_moderators'] = array();
				foreach($context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['moderators'] as $moderators) {
					$cmemcolid = $moderators['id'];
					$profile = &$user_profile[$cmemcolid];
					if(empty($profile['member_group_color']))
						$profile['member_group_color'] = $onlineColor;
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['moderators'][$cmemcolid]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[62] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';

					//Creat the new list...
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[62] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				}
			}
		}
	}
</add after>

<edit file>
$sourcedir/Calendar.php
</edit file>

<search for>
	$bday = array();
</search for>

<add after>
	//Set some standard Variables for the MemberColorLink
	$MemberSetColor = FALSE;
	if (!empty($modSettings['MemberColorBirthday'])) {
		$MemberColor_ID_MEMBER = array();
	}
</add after>

<search for>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'age' => $row['birthYear'] > 4 && $row['birthYear'] <= $age_year ? $age_year - $row['birthYear'] : null,
			'is_last' => false
		);
	}
	mysql_free_result($result);
</search for>

<replace>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'age' => $row['birthYear'] > 4 && $row['birthYear'] <= $age_year ? $age_year - $row['birthYear'] : null,
			'is_last' => false
		);

		//I need to collect some IDs for the MemberColor :).
		if (!empty($modSettings['MemberColorBirthday']) && !empty($row['ID_MEMBER'])) {
			$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
			$MemberSetColor = TRUE;
		}
	}
	mysql_free_result($result);

	if ($MemberSetColor && !empty($MemberColor_ID_MEMBER)) {
		//No compatible Problems ;) (I hope it).
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So i need only the colors... hmmm why schould i not use only the $user_profiles for this... (The Calenderlink is diffrent)
		if (!empty($modSettings['MemberColorBirthday']))
			if (is_array($bday))
				foreach ($bday as $memcalkv => $memcalva)
					foreach ($memcalva as $memcalidkv => $memcalid) {
						$cmemcolid = $memcalid['id'];
						$bday[$memcalkv][$memcalidkv]['color'] = (!empty($user_profile[$cmemcolid]['member_group_color']) ? $user_profile[$cmemcolid]['member_group_color'] : (!empty($user_profile[$cmemcolid]['post_group_color']) ? $user_profile[$cmemcolid]['post_group_color'] : NULL));
					}
	}
</replace>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
	if (!empty($board_info['moderators']))
	{
		// Add a link for each moderator...
		foreach ($board_info['moderators'] as $mod)
			$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
</search for>

<replace>
	if (!empty($board_info['moderators']))
	{
		//I hate it in this way... but what should i do ;)
		if(!empty($modSettings['MemberColorModeratorLinks'])) {
			global $user_profile;

			foreach($board_info['moderators'] as $mod)
				$c[$mod['id']] = $mod['id'];

			loadMemberData($c);
		
			foreach ($board_info['moderators'] as $mod) {
				$cmemcolid = $mod['id'];
				$profile = &$user_profile[$cmemcolid];
					
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[62] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				else
					$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
			}
		}
		else
			foreach ($board_info['moderators'] as $mod)
				$context['link_moderators'][] ='<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
</replace>

<search for>
		$memberContext[$message['ID_MEMBER']]['group'] = $txt[28];
		$memberContext[$message['ID_MEMBER']]['link'] = $message['posterName'];
</search for>

<replace>
		$memberContext[$message['ID_MEMBER']]['group'] = $txt[28];
		$memberContext[$message['ID_MEMBER']]['link'] = (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['posterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
</replace>

<search for>
			if (empty($row['showOnline']))
				$context['view_num_hidden']++;
		}

		// The number of guests is equal to the rows minus the ones we actually used ;).
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);
</search for>

<replace>
				if (!empty($modSettings['MemberColorWhoIsOnline'])) {
					$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
				}

				if (empty($row['showOnline']))
					$context['view_num_hidden']++;
			}

		// The number of guests is equal to the rows minus the ones we actually used ;).
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);
</replace>

<search for>
		// Sort the list.
		krsort($context['view_members']);
		krsort($context['view_members_list']);
	}
</search for>

<add after>
	// Somehow i can do the colors for this in two steps... because the split between first part and the messages...
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);

		//Color for the who is online ;)
		if (!empty($settings['display_who_viewing']) && !empty($modSettings['MemberColorWhoIsOnline']) && !empty($context['view_members'])) {
			//I need the new not numeric keys :)
			$klist = array_keys($context['view_members']);
			foreach($klist as $value) {
				$id = $context['view_members'][$value]['id'];
				$profile = &$user_profile[$id];
				//Let's replace Who is online colors...
				$hidden_user = $context['view_members'][$value]['hidden'];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color'])) {
					$context['view_members'][$value]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
					//Somehow the 'view_members_list' must be the same as before *g*, i don't like the hidden users...
					if (!$hidden_user || allowedTo('moderate_forum'))
						$context['view_members_list'][$value] = ($hidden_user ? '<i>' : '').'<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>'.($hidden_user ? '</i>' : '');
				}
			}
		}
	}
</add after>

<edit file>
$sourcedir/Recent.php
</edit file>

<search for>
	$posts = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentLastPost']))
		$MemberColor_ID_MEMBER = array();	
</add after>

<search for>
		);
	}
	mysql_free_result($request);

	return $posts;
}
</search for>

<replace>
		);

		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_MEMBER']))
				$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
	}
	mysql_free_result($request);


	// Know set the colors for the Recent posts...
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now i can Load the Missing globals :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So Let's Color The Recent Posts ;)
		if (!empty($modSettings['MemberColorRecentLastPost']))
			if (is_array($posts))
				foreach($posts as $postkey => $postid_memcolor) {
					$cmemcolid = $postid_memcolor['poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$posts[$postkey]['poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				}
	}

	return $posts;
}
</replace>

<search for>
	$counter = $_REQUEST['start'] + 1;
	$context['posts'] = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentOwner']) || !empty($modSettings['MemberColorRecentLastPost']))
		$MemberColor_ID_MEMBER = array();
</add after>

<search for>
		if ($ID_MEMBER == $row['ID_FIRST_MEMBER'])
			$board_ids['own'][$row['ID_BOARD']][] = $row['ID_MSG'];
		$board_ids['any'][$row['ID_BOARD']][] = $row['ID_MSG'];
	}
	mysql_free_result($request);
</search for>

<replace>
		if ($ID_MEMBER == $row['ID_FIRST_MEMBER'])
			$board_ids['own'][$row['ID_BOARD']][] = $row['ID_MSG'];
		$board_ids['any'][$row['ID_BOARD']][] = $row['ID_MSG'];

		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['ID_FIRST_MEMBER']))
			$MemberColor_ID_MEMBER[$row['ID_FIRST_MEMBER']] = $row['ID_FIRST_MEMBER'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_MEMBER']))
			$MemberColor_ID_MEMBER[$row['ID_MEMBER']] = $row['ID_MEMBER'];
	}
	mysql_free_result($request);

	// Know set the colors for the Recent posts...
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So Let's Color The Recent Posts ;)
		if (is_array($context['posts']))
			foreach($context['posts'] as $postkey => $postid_memcolor) {
				if (!empty($modSettings['MemberColorRecentLastPost'])) {
					$cmemcolid = $postid_memcolor['poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['posts'][$postkey]['poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				}
				if (!empty($modSettings['MemberColorRecentOwner'])) {
					$cmemcolid = $postid_memcolor['first_poster']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['posts'][$postkey]['first_poster']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				}
			}
	}
</replace>

<search for>
	$context['topics'] = array();
	$topic_ids = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentOwner']) || !empty($modSettings['MemberColorRecentLastPost']))
		$MemberColor_ID_MEMBER = array();
</add after>

<search for>
		);

		determineTopicClass($context['topics'][$row['ID_TOPIC']]);
	}
	mysql_free_result($request);

	if ($is_topics && !empty($modSettings['enableParticipation']) && !empty($topic_ids))
</search for>

<replace>
		);

		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['ID_FIRST_MEMBER']))
			$MemberColor_ID_MEMBER[$row['ID_FIRST_MEMBER']] = $row['ID_FIRST_MEMBER'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_LAST_MEMBER']))
			$MemberColor_ID_MEMBER[$row['ID_LAST_MEMBER']] = $row['ID_LAST_MEMBER'];

		determineTopicClass($context['topics'][$row['ID_TOPIC']]);
	}
	mysql_free_result($request);

	// Know set the colors for the Recent posts...
	if (!empty($settings['display_who_viewing']) && !empty($MemberColor_ID_MEMBER)) {
		//Now i can Load the Missing global :)
		global $user_profile;

		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;

		//So Let's Color The Recent Posts ;)
		if (is_array($context['topics']))
			foreach($context['topics'] as $postkey => $postid_memcolor) {
				if (!empty($modSettings['MemberColorRecentLastPost'])) {
					$cmemcolid = $postid_memcolor['last_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['topics'][$postkey]['last_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				}
				if (!empty($modSettings['MemberColorRecentOwner'])) {
					$cmemcolid = $postid_memcolor['first_post']['member']['id'];
					$profile = &$user_profile[$cmemcolid];
					if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
						$context['topics'][$postkey]['first_post']['member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				}
			}
	}

	if ($is_topics && !empty($modSettings['enableParticipation']) && !empty($topic_ids))
</replace>

<edit file>
$sourcedir/PersonalMessage.php
</edit file>

<search for>
	$context['allow_hide_email'] = !empty($modSettings['allow_hideEmail']);
	$context['from_or_to'] = $context['folder'] != 'outbox' ? 'from' : 'to';
	$context['get_pmessage'] = 'prepareMessageContext';

	$labelQuery = $context['folder'] != 'outbox' ? "
			AND FIND_IN_SET('$context[current_label_id]', pmr.labels)" : '';
</search for>

<add after>
	//Correct a Modsettings sometime there is a problem, and load variables if i need them ;).
	$colormodcheck = 'MemberColorInbox';
	if ($context['folder'] == 'outbox') $colormodcheck = 'MemberColorOutbox';
	$MemberSetColor = FALSE;
	if (empty($modSettings[$colormodcheck]) && !empty($modSettings['MemberColorLink'])) 
		$modSettings['MemberColorLink'] = NULL;
	if (!empty($modSettings[$colormodcheck])) {
		$MemberColor_ID_MEMBER = array();
		$MemberColor_IM_ID = array();
	}
</add after>

<search for>
		}
		mysql_free_result($request);

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);
</search for>

<replace>
			if (!empty($row['ID_MEMBER_TO']) && !empty($modSettings[$colormodcheck])) {
				$MemberSetColor = TRUE;
				$posters[] = $row['ID_MEMBER_TO'];
				// Hmmm somehow i must know what i should replace... i hope i do it right...
				$MemberColor_IM_ID[$row['ID_PM']][empty($row['bcc']) ? 'to' : 'bcc'][] = $row['ID_MEMBER_TO'];
			}
			elseif (empty($row['ID_MEMBER_TO']) && (!empty($modSettings['MemberColorOutbox']) || !empty($modSettings['MemberColorInbox']))) 
				$MemberColor_IM_ID[$row['ID_PM']][empty($row['bcc']) ? 'to' : 'bcc'][] = NULL;
		}

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);

		//So i must correct the link ;) i need only the membercontext for this (a little bit faster)
		if ($MemberSetColor && !empty($MemberColor_IM_ID)) {
			//Now i can Load the Missing global :)
			global $user_profile;
	
			//So let's replace the links...
			foreach($MemberColor_IM_ID as $pmid => $pmidarray) {
				if (!empty($pmidarray['to'])) 
					foreach($pmidarray['to'] as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['to'][$pm_meber_key]) && (!empty($user_profile[$pm_member_id]['member_group_color']) || !empty($user_profile[$pm_member_id]['post_group_color']))) {
							$profile = $user_profile[$pm_member_id];
							$recipients[$pmid]['to'][$pm_meber_key] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
						}
					}
				if (!empty($pmidarray['bcc'])) 					
					foreach($pmidarray['bcc']  as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['bcc'][$pm_meber_key]) && (!empty($user_profile[$pm_member_id]['member_group_color']) || !empty($user_profile[$pm_member_id]['post_group_color']))) {
							$profile = $user_profile[$pm_member_id];
							$recipients[$pmid]['bcc'][$pm_meber_key] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
						}
					}
			}
		}
</replace>

<edit file>
$sourcedir/Stats.php
</edit file>

<search for>
		$context['top_posters'][] = array(
			'name' => $row_members['realName'],
			'id' => $row_members['ID_MEMBER'],
			'num_posts' => $row_members['posts'],
			'href' => $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'] . '">' . $row_members['realName'] . '</a>'
		);
</search for>

<add after>
		
		if (!empty($modSettings['MemberColorStats']))
			$MemberColor_ID_MEMBER[$row_members['ID_MEMBER']] = $row_members['ID_MEMBER'];
</add after>

<search for>
		$context['top_boards'][] = array(
			'id' => $row_board['ID_BOARD'],
			'name' => $row_board['name'],
			'num_posts' => $row_board['numPosts'],
			'href' => $scripturl . '?board=' . $row_board['ID_BOARD'] . '.0',
			'link' => '<a href="' . $scripturl . '?board=' . $row_board['ID_BOARD'] . '.0">' . $row_board['name'] . '</a>'
		);
</search for>

<add after>

		if (!empty($modSettings['MemberColorStats']))
			$MemberColor_ID_MEMBER[$row_members['ID_MEMBER_STARTED']] = $row_members['ID_MEMBER_STARTED'];
</add after>

<search for>
		$context['top_time_online'][] = array(
			'id' => $row_members['ID_MEMBER'],
			'name' => $row_members['realName'],
			'time_online' => $timelogged,
			'seconds_online' => $row_members['totalTimeLoggedIn'],
			'href' => $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'] . '">' . $row_members['realName'] . '</a>'
		);
</search for>

<add after>

		if (!empty($modSettings['MemberColorStats']))
			$MemberColor_ID_MEMBER[$row_members['ID_MEMBER']] = $row_members['ID_MEMBER'];
</add after>

<search for>
	foreach ($context['top_time_online'] as $i => $member)
		$context['top_time_online'][$i]['time_percent'] = round(($member['seconds_online'] * 100) / $max_time_online);
</search for>

<add after>
	
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$MemberColor_ID_MEMBER[$modSettings['latestMember']] = $modSettings['latestMember'];
	
	//Yeah baby give me some colors =).
	if (!empty($MemberColor_ID_MEMBER)) {
		//Now Load the Missing global :)
		global $user_profile;
		loadMemberData($MemberColor_ID_MEMBER);
		$cmemcolid = NULL;
		if (!empty($modSettings['MemberColorStats'])) {
			// First the Top Posters =)
			foreach($context['top_posters'] as $key => $value) {
				$cmemcolid = $context['top_posters'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_posters'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
			}
			// First the Top Starter =)		
			foreach($context['top_starters'] as $key => $value) {
				$cmemcolid = $context['top_starters'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_starters'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
			}
			// First the Top Onliner =)				
			foreach($context['top_time_online'] as $key => $value) {
				$cmemcolid = $context['top_time_online'][$key]['id'];
				$profile = &$user_profile[$cmemcolid];
				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['top_time_online'][$key]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
			}
		}
		if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
			$profile = &$user_profile[$modSettings['latestMember']];
			if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
				$context['latest_member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
		}
	}
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
	// This looks weird, but it's because BoardIndex.php references the variable.
	$context['common_stats']['latest_member'] = array(
		'id' => $modSettings['latestMember'],
		'name' => $modSettings['latestRealName'],
		'href' => $scripturl . '?action=profile;u=' . $modSettings['latestMember'],
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $modSettings['latestMember'] . '">' . $modSettings['latestRealName'] . '</a>',
	);
</search for>

<add after>
	//Latest user need some colors... How could you put this into this file... i hate you... i hope no one read this :P
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
		global $user_profile;
		loadMemberData($modSettings['latestMember']);
		$profile = &$user_profile[$modSettings['latestMember']];
		if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
			$context['common_stats']['latest_member']['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
	}
</add after>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
	if (!empty($board_info['moderators']))
	{
		foreach ($board_info['moderators'] as $mod)
			$context['link_moderators'][] ='<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
</search for>

<replace>
	if (!empty($board_info['moderators']))
	{
		//I hate it in this way... but what should i do ;)
		if(!empty($modSettings['MemberColorModeratorLinks'])) {
			global $user_profile;

			foreach($board_info['moderators'] as $mod)
				$c[$mod['id']] = $mod['id'];

			loadMemberData($c);

			foreach ($board_info['moderators'] as $mod) {
				$cmemcolid = $mod['id'];
				$profile = &$user_profile[$cmemcolid];

				if(!empty($profile['member_group_color']) || !empty($profile['post_group_color']))
					$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[62] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
				else
					$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
			}
		}
		else
			foreach ($board_info['moderators'] as $mod)
				$context['link_moderators'][] ='<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
</replace>

<search for>
			if (!empty($row_board['ID_MODERATOR']))
			{
</search for>

<replace>
			if (!empty($row_board['ID_MODERATOR']))
			{
				//Color the Mods, too...
				if(!empty($modSettings['MemberColorModeratorLinks'])) {
					$MemberSetColor = true;
					$MemberColor_ID_MEMBER[$row_board['ID_MODERATOR']] = $row_board['ID_MODERATOR'];
				}
</replace>

<search for>
							'link' => $row_board['posterName'] != '' ? (!empty($row_board['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['ID_MEMBER'] . '">' . $row_board['realName'] . '</a>' : $row_board['realName']) : $txt[470],
</search for>

<replace>
							'link' => $row_board['posterName'] != '' ? (!empty($row_board['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['ID_MEMBER'] . '">' . $row_board['realName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row_board['realName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')) : $txt[470],
</replace>

<search for>
						'link' => $row['posterName'] != '' ? (!empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>' : $row['realName']) : $txt[470],
</search for>

<replace>
						'link' => $row['posterName'] != '' ? (!empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['realName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')) : $txt[470],
</replace>

<search for>
						'link' => !empty($row['firstID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['firstID_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['firstDisplayName'] . '">' . $row['firstDisplayName'] . '</a>' : $row['firstDisplayName']
</search for>

<replace>
						'link' => !empty($row['firstID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['firstID_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['firstDisplayName'] . '">' . $row['firstDisplayName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['firstDisplayName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
						'link' => !empty($row['lastID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['lastID_MEMBER'] . '">' . $row['lastDisplayName'] . '</a>' : $row['lastDisplayName']
</search for>

<replace>
						'link' => !empty($row['lastID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['lastID_MEMBER'] . '">' . $row['lastDisplayName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['lastDisplayName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<edit file>
$sourcedir/Recent.php
</edit file>

<search for>
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
</search for>

<replace>
				'link' => empty($row['ID_MEMBER']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['posterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
</replace>

<search for>
				'link' => empty($row['ID_FIRST_MEMBER']) ? $row['firstPosterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'] . '">' . $row['firstPosterName'] . '</a>'
</search for>

<replace>
				'link' => empty($row['ID_FIRST_MEMBER']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['firstPosterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'] . '">' . $row['firstPosterName'] . '</a>'
</replace>

<search for>
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'message' => $row['body'],
</search for>

<replace>
				'link' => empty($row['ID_MEMBER']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['posterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'message' => $row['body'],
</replace>

<edit file>
$boarddir/Themes/default/Calendar.template.php
</edit file>

<search for>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</search for>

<replace>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', (!empty($member['color']) ? '<span style="color:'.$member['color'].';">' : ''), $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', (!empty($member['color']) ? '</span>' : ''), '</a>', $member['is_last'] ? '' : ', ';
</replace>

<edit file>
$boarddir/Themes/default/BoardIndex.template.php
</edit file>

<search for>
				<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['is_today'] ? '<b>' : '', $member['name'], $member['is_today'] ? '</b>' : '', isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '<br />' : ', ';
</search for>

<replace>
				<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', (!empty($member['color']) ? '<span style="color:'.$member['color'].';">' : ''), $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', (!empty($member['color']) ? '</span>' : ''), '</a>', $member['is_last'] ? '' : ', ';
</replace>
